'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactRedux = require('react-redux');

var _reactRouter = require('react-router');

var _configureStore = require('./configure-store');

var _configureStore2 = _interopRequireDefault(_configureStore);

var _reactRouterRedux = require('react-router-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var createRoutes = _ref.createRoutes;
  var reducers = _ref.reducers;

  var store = (0, _configureStore2.default)(reducers);
  var history = (0, _reactRouterRedux.syncHistoryWithStore)(_reactRouter.browserHistory, store);
  var routes = createRoutes(history);

  var app = (0, _reactDom.render)(_react2.default.createElement(
    _reactRedux.Provider,
    { store: store },
    routes
  ), document.getElementById('root'));

  if (module.hot) {
    require('react-hot-loader/Injection').RootInstanceProvider.injectProvider({
      getRootInstances: function getRootInstances() {
        return [app];
      }
    });
  }

  return store;
};