'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createServer = function createServer(config, port, host) {
  var serverPort = port || 3000;
  var serverHost = host || '0.0.0.0';
  var compiler = (0, _webpack2.default)(config);
  var app = (0, _express2.default)();

  var staticDir = _path2.default.join(__dirname, '/build');
  app.use('/static', _express2.default.static(staticDir));

  app.use(require('webpack-dev-middleware')(compiler, {
    noInfo: true,
    publicPath: config.output.publicPath
  }));

  app.use(require('webpack-hot-middleware')(compiler));

  app.listen(serverPort, serverHost, function (err) {
    if (err) console.error(err);

    console.log('Listening at http://' + serverHost + ':' + serverPort);
  });

  return app;
}; /* eslint no-console: "off" */


exports.default = createServer;