'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRouter = require('react-router');

var _render = require('./render');

var _render2 = _interopRequireDefault(_render);

var _renderLayout = require('./render-layout');

var _renderLayout2 = _interopRequireDefault(_renderLayout);

var _configureStore = require('./configure-store');

var _configureStore2 = _interopRequireDefault(_configureStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var routes = _ref.routes;
  var reducers = _ref.reducers;
  var app = _ref.app;
  var layout = _ref.layout;

  var store = (0, _configureStore2.default)(reducers);
  var initialState = store.getState();
  var createLayout = layout || _renderLayout2.default;

  app.use('/', function (req, res) {
    (0, _reactRouter.match)({ routes: routes, location: req.url }, function (error, redirectLocation, renderProps) {
      if (error) {
        res.status(500).send(error.message);
      } else if (redirectLocation) {
        res.redirect(302, redirectLocation.pathname + redirectLocation.search);
      } else if (renderProps) {
        var rootMarkup = (0, _render2.default)(renderProps, store);
        res.status(200).send(createLayout({ rootMarkup: rootMarkup, initialState: initialState }));
      } else {
        res.status(404).send('Not found');
      }
    });
  });

  return app;
};